<?php
ini_set( 'display_errors', 1 );
require_once __DIR__ . '/setting.php';
require_once __DIR__ . '/functions.php';

session_start();

$logout_btn = filter_input(INPUT_POST, 'logout_btn');
if($logout_btn){
logout();
}
// パスワードを設定
$password       = PASSWORD;

// フォームからパスワードが送信された場合
if (isset($_POST["login_password"])) {
  // パスワードが一致した場合
  if ($_POST["login_password"] == $password) {
    $_SESSION["logged_in"] = true;
  } else {
    // パスワードが一致しなかった場合、エラーメッセージを表示
    echo "<p>パスワードが間違っています。</p>";
  }
}

$page_title      = PAGE_TITLE;
$file_name       = FILE_NAME;
$text_color      = TEXT_COLOR;
$back_color      = BACK_COLOR;
$image_link      = IMAGE_LINK;
$image_number    = IMAGE_NUMBER;
$image_sort      = IMAGE_SORT;
$image_enlarge   = IMAGE_ENLARGE;
$image_volume    = IMAGE_VOLUME;

$upload_btn = filter_input(INPUT_POST, 'upload_btn');
$del_btn    = filter_input(INPUT_POST, 'del_btn');
$edit_btn    = filter_input(INPUT_POST, 'edit_btn');
$design_btn = filter_input(INPUT_POST, 'design_btn');

$upload_dir  = '../image-orig/';
$masonry_dir = '../image-masonry/';
$datafile    = "../caption.txt";

$err_msgs   = array();
$allow_type = array();
$new_data   = array();

$gd_info = gd_info();
if($gd_info["GIF Read Support"] && $gd_info["GIF Create Support"]) {
  $allow_type[] = 'image/gif';
}
if($gd_info["JPEG Support"]) {
  $allow_type[] = 'image/jpeg';
}
if($gd_info["PNG Support"]) {
  $allow_type[] = 'image/png';
}
if($gd_info["WebP Support"]) {
  $allow_type[] = 'image/webp';
}

if($upload_btn){
$file = $_FILES['uploadfile'];

$tmp_path = $file['tmp_name'];
$file_err = $file['error'];
$filesize = $file['size'];

if(is_uploaded_file($tmp_path)){
$file_type = mime_content_type($tmp_path);
switch ($file_type) {
	case 'image/jpeg':
		$file_ext = 'jpg';
		break;
	case 'image/png':
		$file_ext = 'png';
		break;
	case 'image/gif':
		$file_ext = 'gif';
		break;
	case 'image/webp':
		$file_ext = 'webp';
		break;
}
  if(!in_array($file_type, $allow_type)){
    $err_msgs[] = "利用できる画像ファイルを選択してください。";
  }
} else {
    $err_msgs[] = "ファイルサイズは、" . $image_volume . " バイト以下にしてください。";
}

if($filesize > $image_volume || $file_err == 2){
  $err_msgs[] = "ファイルサイズは、" . $image_volume . " バイト以下にしてください。";
}

if(count($err_msgs) == 0){
$unixtime = date("U");
$save_filename = "img-" . $unixtime . "." . $file_ext;
$save_path = $upload_dir . $save_filename;
    if(move_uploaded_file($tmp_path, $save_path)){
    recordAdd($unixtime, $_POST['caption']);
    thumnail($file_ext);
    } else {
    $err_msgs[] = "ファイルが保存できませんでした。";
    }
  }
}

if($del_btn){
  $info = pathinfo($del_btn);
  delImage($info["filename"]);
  $image_id = preg_replace("/[^0-9]/", "", $del_btn);
  recordDel($image_id);
}

if($edit_btn){
  $edit_caption = $_POST['edit_caption' . $edit_btn];
  captionEdit($edit_btn, $edit_caption);
}

if($design_btn){
  if($file_name != $_POST['file_name']){
    $old_filename = '../' . $file_name . '.php';
    $new_filename = '../' . $_POST['file_name'] . '.php';
    if (file_exists($new_filename)) {
    $filename_msg = '但し、新しいファイル名の ' . $_POST['file_name'] . '.php がすでに存在するため変更できませんでした。';
    $_POST['file_name'] = $file_name;
    } else {
    rename($old_filename, $new_filename);
    }
  }
  createSettingFile($_POST['page_title'], $_POST['file_name'], $_POST['text_color'], $_POST['back_color'], $_POST['image_link'], $_POST['image_number'], $_POST['image_sort'], $_POST['image_enlarge'], $_POST['image_volume'], $_POST['password']);

$page_title      = $_POST['page_title'];
$file_name       = $_POST['file_name'];
$text_color      = $_POST['text_color'];
$back_color      = $_POST['back_color'];
$image_link      = $_POST['image_link'];
$image_number    = $_POST['image_number'];
$image_sort      = $_POST['image_sort'];
$image_enlarge   = $_POST['image_enlarge'];
$image_volume    = $_POST['image_volume'];
$password        = $_POST['password'];
  $update_msg = "更新しました。";
}

$images = glob($masonry_dir . "*");
$images = array_reverse($images);

getCaption();
?>
<!DOCTYPE html>
<html>
<head>
<meta charset="utf-8">
<meta name="viewport" content="width=device-width">
<title>管理画面</title>
<link rel="icon" href="./favicon.svg" type="image/svg+xml">
<link rel="preconnect" href="https://fonts.googleapis.com">
<link rel="preconnect" href="https://fonts.gstatic.com" crossorigin>
<link href="https://fonts.googleapis.com/css2?family=Patua+One&display=swap" rel="stylesheet">
<style>
.images {
  display: flex;
  flex-wrap: wrap;
}
.images > div {
  margin-bottom: 10px;
}
.img_div {
  border: solid 1px black;
  width: 150px;
}
.images img {
  max-width: 100%;
  height: auto;
  display: block;
}
.del_btn_div, .edit_btn_div {
  text-align: right;
}
.caption_div {
  text-align: center;
}
.error {
  color: red;
}
.parent {
  display: flex;
  justify-content: space-between;
}
.flex-container {
  display: flex;
  margin-top: 30px;
}
.flex-image {
  padding: 0 20px;
  flex: 1;
}
.flex-design {
  width: 250px;
  border-left: 3px dashed gray;
  padding-left: 20px;
}
#page_link {
  font-family: 'Patua One', cursive;
  background-color: <?php echo h($back_color); ?>;
  text-align: center;
  padding: 8px;
}
#page_link a {
  color: <?php echo h($text_color); ?>;
  font-size: large;
  text-decoration: none;
}
.flex-design form > div {
  margin-bottom: 10px;
}
.flex-design form > div:last-of-type {
  margin-top: 30px;
}
#logout_btn {
  text-align: right;
}
#caption {
  width: 300px;
}
.edit_caption {
  width: 150px;
  box-sizing: border-box;
}
#page_title {
  width: 200px;
  text-align: center;
}
#file_name, #image_volume {
  width: 130px;
  text-align: right;
}
#password {
  width: 200px;
}
.line {
  border-bottom: 1px solid gray;
}
</style>
<script>
    function logoutcheck(){
	if(window.confirm('ログアウトしてよろしいですか？')){ // 確認ダイアログを表示
		return true; // 「OK」時は送信を実行
	}
	else{ // 「キャンセル」時の処理
		window.alert('キャンセルしました。'); // 警告ダイアログを表示
		return false; // 送信を中止
	}
}
    function check(){
	if(window.confirm('削除してよろしいですか？')){ // 確認ダイアログを表示
		return true; // 「OK」時は送信を実行
	}
	else{ // 「キャンセル」時の処理
		return false; // 送信を中止
	}
}
</script>
</head>
<body>
<?php
if(count($err_msgs) != 0) {
  foreach($err_msgs as $msg){
    echo '<div class="error">';
    echo h($msg);
    echo '</div>';
  }
}
?>

<?php if (isset($_SESSION["logged_in"])): ?>
<div class="parent">
  <div class="child1">
    <form id="upload-form" method="post" enctype="multipart/form-data">
      <div class="text">
        <input type="text" maxlength="50" id="caption" name="caption" placeholder="画像の説明（50文字以内）">
      </div>
      <div class="file-up">
        <input type="hidden" name="MAX_FILE_SIZE" value="<?php echo h($image_volume); ?>">
        <input type="hidden" name="upload_btn" value="upload_btn">
        <input type="file" id="file-input" name="uploadfile" accept="<?php echo h(implode(',', $allow_type)); ?>" />
      </div>
    </form>
  </div>

  <div class="child2">
    <form method="post" onSubmit="return logoutcheck()">
    <div id="logout_btn">
    <button type="submit" name="logout_btn" value="logout_btn">ログアウト</button>
    </div>
  </form>
  </div>
</div>

<div class="flex-container">
  <div class="flex-image">
  <form method="post" id="edit_form"></form>
  <form method="post" onSubmit="return check()">
  <div class="images">
<?php foreach($images as $image): ?>
  <div>
    <div class="del_btn_div"><button type="submit" name="del_btn" value="<?php echo h($image); ?>">削除</button></div>
    <div class="img_div"><img src="<?php echo h($image); ?>" title="<?php
    $image_id = preg_replace("/[^0-9]/", "", $image);
    if (array_key_exists($image_id, $new_data)) {
      echo h($new_data[$image_id]);
      }
    ?>" alt=""></div>
    <div class="caption_div"><input type="text" maxlength="50" class="edit_caption" name="edit_caption<?php echo h($image_id); ?>" value="<?php
    if (array_key_exists($image_id, $new_data)) {
      echo h($new_data[$image_id]);
      }
    ?>" form="edit_form"></div>
    <div class="edit_btn_div"><button type="submit" name="edit_btn" value="<?php echo h($image_id); ?>" form="edit_form">編集</button></div>
  </div>
<?php endforeach; ?>
  </div>
  </form>
  </div>

  <div class="flex-design">
  <div class="line"></div>
  <p id="page_link"><a href="../<?php echo h($file_name); ?>.php" target="_blank"><?php echo h($page_title); ?></a></p>
  <form method="post">
    <div>
    <label for="page_title">タイトル：</label><br>
      <input type="text" id="page_title" name="page_title" value="<?php echo h($page_title); ?>" required>
    </div>
    <div>
    <label for="file_name">ファイル名：</label><br>
      <input type="text" id="file_name" name="file_name" value="<?php echo h($file_name); ?>" pattern="[0-9a-zA-Z\-_]+" required> .php
    </div>
    <div>
    <label for="text_color">文字色：</label>
      <input type="color" id="text_color" name="text_color" value="<?php echo h($text_color); ?>">
    </div>
    <div>
    <label for="back_color">背景色：</label>
      <input type="color" id="back_color" name="back_color" value="<?php echo h($back_color); ?>">
    </div>
  <div>
    <label for="image_link">リンク：</label>
      <select id="image_link" name="image_link">
        <option value="0"<?php echo ( $image_link == "0" ) ? ' selected' : ''; ?>>無し</option>
        <option value="1"<?php echo ( $image_link == "1" ) ? ' selected' : ''; ?>>有り</option>
      </select>
  </div>
  <div>
    <label for="image_number">画像数：</label>
      <select id="image_number" name="image_number">
        <option value="6"<?php echo ( $image_number == "6" ) ? ' selected' : ''; ?>>6</option>
        <option value="7"<?php echo ( $image_number == "7" ) ? ' selected' : ''; ?>>7</option>
        <option value="8"<?php echo ( $image_number == "8" ) ? ' selected' : ''; ?>>8</option>
        <option value="9"<?php echo ( $image_number == "9" ) ? ' selected' : ''; ?>>9</option>
      </select>
  </div>
  <div>
    <label for="image_sort">並び順：</label>
      <select id="image_sort" name="image_sort">
        <option value="0"<?php echo ( $image_sort == "0" ) ? ' selected' : ''; ?>>ランダム</option>
        <option value="1"<?php echo ( $image_sort == "1" ) ? ' selected' : ''; ?>>新しい</option>
        <option value="2"<?php echo ( $image_sort == "2" ) ? ' selected' : ''; ?>>古い</option>
      </select>
  </div>
  <div>
    <label for="image_enlarge">拡　大：</label>
      <select id="image_enlarge" name="image_enlarge">
        <option value="0"<?php echo ( $image_enlarge == "0" ) ? ' selected' : ''; ?>>しない</option>
        <option value="1"<?php echo ( $image_enlarge == "1" ) ? ' selected' : ''; ?>>する</option>
      </select>
  </div>
  <div class="line"></div>
  <div>
    <label for="image_volume">サイズ制限：</label><br>
    <input type="text" id="image_volume" name="image_volume" value="<?php echo h($image_volume); ?>" required> Bytes
  </div>
  <div class="line"></div>
  <div>
    <label for="password">パスワード：</label><br>
    <input type="text" id="password" name="password" value="<?php echo h($password); ?>" required>
  </div>
  <div class="line"></div>
    <div>
      <button type="submit" name="design_btn" value="design_btn">変更</button>
    </div>
  </form>

<?php
if(isset($update_msg)) {
    echo '<p class="error">';
    echo h($update_msg);
      if(isset($filename_msg)){
        echo '<br>' . h($filename_msg);
        }
    echo '</p>';
}
?>
  </div>

</div>
<?php else: ?>

        <form method='post'>
        <p><input type='password' name='login_password' placeholder="パスワード" autofocus></p>
        </form>

<?php endif; ?>
<script>
  // input 要素を取得
  var fileInput = document.getElementById("file-input");
  // change イベントを監視
  fileInput.addEventListener("change", function() {
    // ファイルが選択されたら
    if (fileInput.files.length > 0) {
      // フォーム要素を取得
      var uploadForm = document.getElementById("upload-form");
      // フォームを送信
      uploadForm.submit();
    }
  });

const input0 = document.getElementById('page_title');
input0.addEventListener('input', updateValue0, false);
function updateValue0(e0) {
  target1.innerText = e0.target.value;
}
const input1 = document.getElementById('text_color');
const target1 = document.querySelector('#page_link a');
input1.addEventListener('input', updateValue1, false);
function updateValue1(e1) {
  target1.style.setProperty('color', e1.target.value);
}
const input2 = document.getElementById('back_color');
const target2 = document.getElementById('page_link');
input2.addEventListener('input', updateValue2, false);
function updateValue2(e2) {
  target2.style.setProperty('background-color', e2.target.value);
}
</script>
</body>
</html>

